# wxPalette Class Reference
[Graphics Device Interface (GDI)]

`#include <wx/palette.h>`

Inheritance diagram for wxPalette:
[legend]

## Detailed Description

A palette is a table that maps pixel values to RGB colours.

It allows the colours of a low-depth bitmap, for example, to be mapped to the available colours in a display. The notion of palettes is becoming more and more obsolete nowadays and only the MSW port is still using a native palette. All other ports use generic code which is basically just an array of colours.

It is likely that in the future the only use for palettes within wxWidgets will be for representing colour indeces from images (such as GIF or PNG). The image handlers for these formats have been modified to create a palette if there is such information in the original image file (usually 256 or less colour images). See wxImage for more information.

##

Library: wxCore

Category: Graphics Device Interface (GDI)

Predefined objects/pointers: wxNullPalette

See also:
  wxDC::SetPalette(), wxBitmap

## Public Member Functions
| wxPalette ()
| Default constructor.
| wxPalette (const wxPalette &palette)
| Copy constructor, uses Reference Counting.
| wxPalette (int n, const unsigned char *red, const unsigned char *green, const unsigned char *blue)
| Creates a palette from arrays of size n, one for each red, blue or green component.
virtual | ~wxPalette ()
| Destructor.
bool | Create (int n, const unsigned char *red, const unsigned char *green, const unsigned char *blue)
| Creates a palette from arrays of size n, one for each red, blue or green component.
virtual int | GetColoursCount () const
| Returns number of entries in palette.
int | GetPixel (unsigned char red, unsigned char green, unsigned char blue) const
| Returns a pixel value (index into the palette) for the given RGB values.
bool | GetRGB (int pixel, unsigned char *red, unsigned char *green, unsigned char *blue) const
| Returns RGB values for a given palette index.
virtual bool | IsOk () const
| Returns true if palette data is present.
wxPalette & | operator= (const wxPalette &palette)
| Assignment operator, using Reference Counting.

List of all members.

## Constructor & Destructor Documentation

wxPalette::wxPalette | ( |  | ) |

Default constructor.

wxPalette::wxPalette | ( | const wxPalette & | palette | ) |

Copy constructor, uses Reference Counting.

Parameters:

  | palette | A reference to the palette to copy.

wxPalette::wxPalette | ( | int | n,
|  | const unsigned char * | red,
|  | const unsigned char * | green,
|  | const unsigned char * | blue |
| ) |  |  |

Creates a palette from arrays of size n, one for each red, blue or green component.

Parameters:

  | n | The number of indices in the palette.
  | red | An array of red values.
  | green | An array of green values.
  | blue | An array of blue values.

wxPerl Note: In wxPerl this method takes as parameters 3 array references (they must be of the same length).

See also:
  Create()

virtual wxPalette::~wxPalette | ( |  | ) | `[virtual]`

Destructor.

See also:
  reference-counted object destruction

## Member Function Documentation

bool wxPalette::Create | ( | int | n,
|  | const unsigned char * | red,
|  | const unsigned char * | green,
|  | const unsigned char * | blue |
| ) |  |  |

Creates a palette from arrays of size n, one for each red, blue or green component.

Parameters:

  | n | The number of indices in the palette.
  | red | An array of red values.
  | green | An array of green values.
  | blue | An array of blue values.

Returns:
  true if the creation was successful, false otherwise.

See also:
  wxPalette()

virtual int wxPalette::GetColoursCount | ( |  | ) | const`[virtual]`

Returns number of entries in palette.

int wxPalette::GetPixel | ( | unsigned char | red,
|  | unsigned char | green,
|  | unsigned char | blue |
| ) |  |  | const

Returns a pixel value (index into the palette) for the given RGB values.

Parameters:

  | red | Red value.
  | green | Green value.
  | blue | Blue value.

Returns:
  The nearest palette index or `wxNOT_FOUND` for unexpected errors.

See also:
  GetRGB()

bool wxPalette::GetRGB | ( | int | pixel,
|  | unsigned char * | red,
|  | unsigned char * | green,
|  | unsigned char * | blue |
| ) |  |  | const

Returns RGB values for a given palette index.

Parameters:

  | pixel | The palette index.
  | red | Receives the red value.
  | green | Receives the green value.
  | blue | Receives the blue value.

Returns:
  true if the operation was successful.

wxPerl Note: In wxPerl this method takes only the pixel parameter and returns a 3-element list (or the empty list upon failure).

See also:
  GetPixel()

virtual bool wxPalette::IsOk | ( |  | ) | const`[virtual]`

Returns true if palette data is present.

wxPalette& wxPalette::operator= | ( | const wxPalette & | palette | ) |

Assignment operator, using Reference Counting.

|  | [ top ]